<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>SpotEventDetector - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Image.html">Image</a><ul class='methods'><li data-type='method' style='display: none;'><a href="Image.html#set">set</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-Setter.html">Setter</a><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#.getSetters">getSetters</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-Similarity.html">Similarity</a><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#.getSimilarities">getSimilarities</a></li></ul></li><li><a href="commands.html">commands</a></li><li><a href="aidecv.html">aidecv</a><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv.html#.BlobSetter::blob">BlobSetter::blob</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.DrawSetter::draw">DrawSetter::draw</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.EdgeSetter::edge">EdgeSetter::edge</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.FoveaSetter::setFovea">FoveaSetter::setFovea</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.HistogramSetter::getMode">HistogramSetter::getMode</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.HistogramSetter::getMode">HistogramSetter::getMode</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.HistogramSetter::doPlot">HistogramSetter::doPlot</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.HistogramSetter::doSmooth">HistogramSetter::doSmooth</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.HistogramSetter::getDivergence">HistogramSetter::getDivergence</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2mat">mat2mat</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2json">mat2json</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2txt">mat2txt</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.bgr2bin">bgr2bin</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.SegmentSetter::segment">SegmentSetter::segment</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.SmoothSetter::smooth">SmoothSetter::smooth</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.SubtractSetter::subtract">SubtractSetter::subtract</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-opencvwindow.html">opencvwindow</a><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.waitUntilWindowsClosed">waitUntilWindowsClosed</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-SpotEventDetector.html">SpotEventDetector</a><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-SpotEventDetector.html#backgroundRegister">backgroundRegister</a></li><li data-type='method' style='display: none;'><a href="aidecv-SpotEventDetector.html#grab">grab</a></li><li data-type='method' style='display: none;'><a href="aidecv-SpotEventDetector.html#next">next</a></li></ul></li></ul>
</nav>

<div id="main">
    
    <h1 class="page-title">SpotEventDetector</h1>
    

    




<section>

<header>
    
        <h2>
            <span class="ancestors"><a href="aidecv.html">aidecv</a>~</span>
        
        SpotEventDetector
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="SpotEventDetector"><span class="type-signature"></span>new SpotEventDetector<span class="signature">(device<span class="signature-attributes">opt</span>, foreground_threshold<span class="signature-attributes">opt</span>, background_count<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Implements a spotter, i.e., an event detector that detects a motion over a background.</p>
</div>











    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>device</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The input device.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>foreground_threshold</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>500</code>
                
                </td>
            

            <td class="description last"><p>The foreground threshold detection level.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>background_count</code></td>
            

            <td class="type">
            
                
<span class="param-type">unit</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>20</code>
                
                </td>
            

            <td class="description last"><p>The number of frame to average for the background.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id="~input"><span class="type-signature">(inner) </span>input<span class="type-signature"> :Map</span></h4>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>The last grabbed image, in <code>CV_8UC3</code> format..</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Map</span>


        </li>
    </ul>






        
            
<h4 class="name" id="~bgmask"><span class="type-signature">(inner) </span>bgmask<span class="type-signature"> :Map</span></h4>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>The last background mask, in <code>CV_8UC1</code> format..</p>
<ul>
<li>Background pixels values are set to <code>0</code>, foreground values are set to <code>128</code> or <code>255</code>.</li>
</ul>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Map</span>


        </li>
    </ul>






        
            
<h4 class="name" id="~motionPercentage"><span class="type-signature">(inner) </span>motionPercentage<span class="type-signature"> :uint</span></h4>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>The last proportion of moving pixels in percentage, between 0 and 100%.</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">uint</span>


        </li>
    </ul>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="backgroundRegister"><span class="type-signature"></span>backgroundRegister<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Registers the background.</p>
</div>




























        
            

    

    <h4 class="name" id="grab"><span class="type-signature"></span>grab<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Grabs and detect the background.</p>
</div>

























<h5>Returns:</h5>

        
<div class="param-desc">
    <p>The last proportion of moving pixels in percentage, between 0 and 100%.</p>
</div>



    



        
            

    

    <h4 class="name" id="next"><span class="type-signature"></span>next<span class="signature">(move_else_still<span class="signature-attributes">opt</span>, motion_threshold<span class="signature-attributes">opt</span>, watchdog_delay<span class="signature-attributes">opt</span>, stabilization_count<span class="signature-attributes">opt</span>, verbose<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Waits until the next stable image and returns it, thus block the program until detection or timeout.</p>
</div>











    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>move_else_still</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If true detects when above the threshold, if false detects when under the threshold.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>motion_threshold</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>10</code>
                
                </td>
            

            <td class="description last"><p>The motion threshold in percentage, as provided by grab(), to detect the next event.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>watchdog_delay</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The maximal delay to wait for an event, in milli-seconds, default is 0, i.e., waiting forever.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>stabilization_count</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>2</code>
                
                </td>
            

            <td class="description last"><p>Number of frames before the event is considered as stable and not spurious.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>verbose</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>If true, prints a trace during the detection delay.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2022-11-06 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>